(define-module (alterator atlas)
  :use-module (srfi srfi-1)

  :use-module (alterator algo)
  :use-module (alterator str)
  :export (open-ui-path))

;; all ui files in
;; $ALTERATOR_DATADIR/ui/<name>.scm and
;; $ALTERATOR_DATADIR/ui/<name>/index.scm
(define (make-ui-path name)
  (append-map
    (lambda (dir)
      (list (string-append dir "/ui" (->string name) ".scm")
            (string-append dir "/ui" (->string name) "/index.scm")))
    (string-cut (getenv "ALTERATOR_DATADIR") #\:)))

(define (open/ignore path)
  (catch/ignore
      'system-error
          (lambda() (open-input-file path))))

(define (open-ui-path url)
  (or (any open/ignore (make-ui-path url))
      (error (format #f "Unable to open url ~S~%" url))))
