(define-module (alterator lookout widget)
  :use-module (srfi srfi-1)

  :use-module (alterator algo)
  :use-module (alterator object)
  :use-module (alterator presentation container)
  :export (join-args
           make-widget))

(define (not-default-args args)
  (or (null? args)
      (memq (instance-of (cond-car args))
	    '(<attribute> <empty-attribute>))))

(define (join-args args default-args default-args-len)
  (let* ((len (if (not-default-args args) 0 default-args-len)))
    (append (map (lambda(x y) (x y)) default-args (take args len))
	    (list-tail args len))))

;;create simple widgets
(define (make-widget type . default-args)
  (let ((default-args-len (length default-args)))
    (lambda args
      (let ((container (make-container type)))
	(container (join-args args default-args default-args-len))
	container))))

(define-macro (with-widgets <presentations> <instruction> . <instructions>)
  `(let ,(map (lambda(item) `(,(car item) (make-widget ,@(cdr item)))) <presentations>)
     ,<instruction> . ,<instructions>))
